Whamcloud - gitweb
branch: HEAD
[fs/lustre-release.git] / lustre / tests / sanityN.sh
1 #!/bin/bash
2
3 set -e
4
5 ONLY=${ONLY:-"$*"}
6 # bug number for skipped test:  3192 9977
7 ALWAYS_EXCEPT="14b 28 $SANITYN_EXCEPT"
8 # UPDATE THE COMMENT ABOVE WITH BUG NUMBERS WHEN CHANGING ALWAYS_EXCEPT!
9
10 # bug number for skipped test:                                                    12652 12652
11 grep -q 'Enterprise Server 10' /etc/SuSE-release && ALWAYS_EXCEPT="$ALWAYS_EXCEPT 11    14" || true
12
13 # Tests that fail on uml
14 [ "$UML" = "true" ] && EXCEPT="$EXCEPT 7"
15
16 # Join file feature is not supported currently.
17 # It will be ported soon.
18 EXCEPT="$EXCEPT 22"
19
20 SRCDIR=`dirname $0`
21 PATH=$PWD/$SRCDIR:$SRCDIR:$SRCDIR/../utils:$PATH
22
23 SIZE=${SIZE:-40960}
24 CHECKSTAT=${CHECKSTAT:-"checkstat -v"}
25 CREATETEST=${CREATETEST:-createtest}
26 GETSTRIPE=${GETSTRIPE:-lfs getstripe}
27 SETSTRIPE=${SETSTRIPE:-lstripe}
28 MCREATE=${MCREATE:-mcreate}
29 OPENFILE=${OPENFILE:-openfile}
30 OPENUNLINK=${OPENUNLINK:-openunlink}
31 TOEXCL=${TOEXCL:-toexcl}
32 TRUNCATE=${TRUNCATE:-truncate}
33 export TMP=${TMP:-/tmp}
34 MOUNT_2=${MOUNT_2:-"yes"}
35 CHECK_GRANT=${CHECK_GRANT:-"yes"}
36 GRANT_CHECK_LIST=${GRANT_CHECK_LIST:-""}
37
38 SAVE_PWD=$PWD
39
40 export NAME=${NAME:-local}
41
42 LUSTRE=${LUSTRE:-`dirname $0`/..}
43 . $LUSTRE/tests/test-framework.sh
44 CLEANUP=${CLEANUP:-:}
45 SETUP=${SETUP:-:}
46 init_test_env $@
47 . ${CONFIG:=$LUSTRE/tests/cfg/$NAME.sh}
48
49 [ "$SLOW" = "no" ] && EXCEPT_SLOW="12 16"
50
51 SANITYLOG=${TESTSUITELOG:-$TMP/$(basename $0 .sh).log}
52 FAIL_ON_ERROR=false
53
54 SETUP=${SETUP:-:}
55 TRACE=${TRACE:-""}
56
57 LPROC=/proc/fs/lustre
58
59 [ "$SANITYLOG" ] && rm -f $SANITYLOG || true
60
61 check_and_setup_lustre
62
63 LPROC=/proc/fs/lustre
64 LOVNAME=`lctl get_param -n llite.*.lov.common_name | tail -n 1`
65 OSTCOUNT=`lctl get_param -n lov.$LOVNAME.numobd`
66
67 rm -rf $DIR1/[df][0-9]* $DIR1/lnk
68
69 # $RUNAS_ID may get set incorrectly somewhere else
70 [ $UID -eq 0 -a $RUNAS_ID -eq 0 ] && error "\$RUNAS_ID set to 0, but \$UID is also 0!"
71
72 check_runas_id $RUNAS_ID $RUNAS
73
74 build_test_filter
75
76 test_1a() {
77         touch $DIR1/f1
78         [ -f $DIR2/f1 ] || error
79 }
80 run_test 1a "check create on 2 mtpt's =========================="
81
82 test_1b() {
83         chmod 777 $DIR2/f1
84         $CHECKSTAT -t file -p 0777 $DIR1/f1 || error
85         chmod a-x $DIR2/f1
86 }
87 run_test 1b "check attribute updates on 2 mtpt's ==============="
88
89 test_1c() {
90         $CHECKSTAT -t file -p 0666 $DIR1/f1 || error
91 }
92 run_test 1c "check after remount attribute updates on 2 mtpt's ="
93
94 test_1d() {
95         rm $DIR2/f1
96         $CHECKSTAT -a $DIR1/f1 || error
97 }
98 run_test 1d "unlink on one mountpoint removes file on other ===="
99
100 test_2a() {
101         touch $DIR1/f2a
102         ls -l $DIR2/f2a
103         chmod 777 $DIR2/f2a
104         $CHECKSTAT -t file -p 0777 $DIR1/f2a || error
105 }
106 run_test 2a "check cached attribute updates on 2 mtpt's ========"
107
108 test_2b() {
109         touch $DIR1/f2b
110         ls -l $DIR2/f2b
111         chmod 777 $DIR1/f2b
112         $CHECKSTAT -t file -p 0777 $DIR2/f2b || error
113 }
114 run_test 2b "check cached attribute updates on 2 mtpt's ========"
115
116 # NEED TO SAVE ROOT DIR MODE
117 test_2c() {
118         chmod 777 $DIR1
119         $CHECKSTAT -t dir -p 0777 $DIR2 || error
120 }
121 run_test 2c "check cached attribute updates on 2 mtpt's root ==="
122
123 test_2d() {
124         chmod 755 $DIR1
125         $CHECKSTAT -t dir -p 0755 $DIR2 || error
126 }
127 run_test 2d "check cached attribute updates on 2 mtpt's root ==="
128
129 test_2e() {
130         chmod 755 $DIR1
131         ls -l $DIR1
132         ls -l $DIR2
133         chmod 777 $DIR1
134         $RUNAS dd if=/dev/zero of=$DIR2/$tfile count=1 || error
135 }
136 run_test 2e "check chmod on root is propagated to others"
137
138 test_3() {
139         ( cd $DIR1 ; ln -s this/is/good lnk )
140         [ "this/is/good" = "`perl -e 'print readlink("'$DIR2/lnk'");'`" ] || \
141                 error
142 }
143 run_test 3 "symlink on one mtpt, readlink on another ==========="
144
145 test_4() {
146         multifstat $DIR1/f4 $DIR2/f4
147 }
148 run_test 4 "fstat validation on multiple mount points =========="
149
150 test_5() {
151         mcreate $DIR1/f5
152         truncate $DIR2/f5 100
153         $CHECKSTAT -t file -s 100 $DIR1/f5 || error
154         rm $DIR1/f5
155 }
156 run_test 5 "create a file on one mount, truncate it on the other"
157
158 test_6() {
159         openunlink $DIR1/$tfile $DIR2/$tfile || \
160                 error "openunlink $DIR1/$tfile $DIR2/$tfile"
161 }
162 run_test 6 "remove of open file on other node =================="
163
164 test_7() {
165         # run_one creates uniq $tdir (bug 13798)
166         # opendirunlink failes if it exists
167         rmdir $DIR1/$tdir || true
168         opendirunlink $DIR1/$tdir $DIR2/$tdir || \
169                 error "opendirunlink $DIR1/$tdir $DIR2/$tdir"
170 }
171 run_test 7 "remove of open directory on other node ============="
172
173 test_8() {
174         opendevunlink $DIR1/$tfile $DIR2/$tfile || \
175                 error "opendevunlink $DIR1/$tfile $DIR2/$tfile"
176 }
177 run_test 8 "remove of open special file on other node =========="
178
179 test_9() {
180         MTPT=1
181         > $DIR2/f9
182         for C in a b c d e f g h i j k l; do
183                 DIR=`eval echo \\$DIR$MTPT`
184                 echo -n $C >> $DIR/f9
185                 [ "$MTPT" -eq 1 ] && MTPT=2 || MTPT=1
186         done
187         [ "`cat $DIR1/f9`" = "abcdefghijkl" ] || \
188                 error "`od -a $DIR1/f9` != abcdefghijkl"
189 }
190 run_test 9 "append of file with sub-page size on multiple mounts"
191
192 test_10a() {
193         MTPT=1
194         OFFSET=0
195         > $DIR2/f10
196         for C in a b c d e f g h i j k l; do
197                 DIR=`eval echo \\$DIR$MTPT`
198                 echo -n $C | dd of=$DIR/f10 bs=1 seek=$OFFSET count=1
199                 [ "$MTPT" -eq 1 ] && MTPT=2 || MTPT=1
200                 OFFSET=`expr $OFFSET + 1`
201         done
202         [ "`cat $DIR1/f10`" = "abcdefghijkl" ] || \
203                 error "`od -a $DIR1/f10` != abcdefghijkl"
204 }
205 run_test 10a "write of file with sub-page size on multiple mounts "
206
207 test_10b() {
208         yes "R" | dd of=$DIR1/f10b bs=3k count=1 || error "dd $DIR1"
209
210         truncate $DIR1/f10b 4096 || error "truncate 4096"
211
212         dd if=$DIR2/f10b of=$TMP/f10b-lustre bs=4k count=1 || error "dd $DIR2"
213
214         # create a test file locally to compare
215         yes "R" | dd of=$TMP/f10b bs=3k count=1 || error "dd random"
216         truncate $TMP/f10b 4096 || error "truncate 4096"
217         cmp $TMP/f10b $TMP/f10b-lustre || error "file miscompare"
218         rm $TMP/f10b $TMP/f10b-lustre
219 }
220 run_test 10b "write of file with sub-page size on multiple mounts "
221
222 test_11() {
223         mkdir $DIR1/d11
224         multiop $DIR1/d11/f O_c &
225         MULTIPID=$!
226         usleep 200
227         cp -p /bin/ls $DIR1/d11/f
228         $DIR2/d11/f
229         RC=$?
230         kill -USR1 $MULTIPID
231         wait $MULTIPID || error
232         [ $RC -eq 0 ] && error || true
233 }
234 run_test 11 "execution of file opened for write should return error ===="
235
236 test_12() {
237        DIR=$DIR DIR2=$DIR2 sh lockorder.sh
238 }
239 run_test 12 "test lock ordering (link, stat, unlink) ==========="
240
241 test_13() {     # bug 2451 - directory coherency
242        rm -rf $DIR1/d13
243        mkdir $DIR1/d13 || error
244        cd $DIR1/d13 || error
245        ls
246        ( touch $DIR1/d13/f13 ) # needs to be a separate shell
247        ls
248        rm -f $DIR2/d13/f13 || error
249        ls 2>&1 | grep f13 && error "f13 shouldn't return an error (1)" || true
250        # need to run it twice
251        ( touch $DIR1/d13/f13 ) # needs to be a separate shell
252        ls
253        rm -f $DIR2/d13/f13 || error
254        ls 2>&1 | grep f13 && error "f13 shouldn't return an error (2)" || true
255 }
256 run_test 13 "test directory page revocation ===================="
257
258 test_14() {
259         mkdir $DIR1/d14
260         cp -p /bin/ls $DIR1/d14/ls
261         exec 100>> $DIR1/d14/ls
262         $DIR2/d14/ls && error || true
263         exec 100<&-
264 }
265 run_test 14 "execution of file open for write returns -ETXTBSY ="
266
267 test_14a() {
268         mkdir -p $DIR1/d14
269         cp -p `which multiop` $DIR1/d14/multiop || error "cp failed"
270         $DIR1/d14/multiop $TMP/test14.junk O_c &
271         MULTIPID=$!
272         sleep 1
273         multiop $DIR2/d14/multiop Oc && error "expected error, got success"
274         kill -USR1 $MULTIPID || return 2
275         wait $MULTIPID || return 3
276         rm $TMP/test14.junk $DIR1/d14/multiop || error "removing multiop"
277 }
278 run_test 14a "open(RDWR) of executing file returns -ETXTBSY ===="
279
280 test_14b() { # bug 3192, 7040
281         mkdir -p $DIR1/d14
282         cp -p `which multiop` $DIR1/d14/multiop || error "cp failed"
283         $DIR1/d14/multiop $TMP/test14.junk O_c &
284         MULTIPID=$!
285         sleep 1
286         truncate $DIR2/d14/multiop 0 && kill -9 $MULTIPID && \
287                 error "expected truncate error, got success"
288         kill -USR1 $MULTIPID || return 2
289         wait $MULTIPID || return 3
290         cmp `which multiop` $DIR1/d14/multiop || error "binary changed"
291         rm $TMP/test14.junk $DIR1/d14/multiop || error "removing multiop"
292 }
293 run_test 14b "truncate of executing file returns -ETXTBSY ======"
294
295 test_14c() { # bug 3430, 7040
296         mkdir -p $DIR1/d14
297         cp -p `which multiop` $DIR1/d14/multiop || error "cp failed"
298         $DIR1/d14/multiop $TMP/test14.junk O_c &
299         MULTIPID=$!
300         sleep 1
301         cp /etc/hosts $DIR2/d14/multiop && error "expected error, got success"
302         kill -USR1 $MULTIPID || return 2
303         wait $MULTIPID || return 3
304         cmp `which multiop` $DIR1/d14/multiop || error "binary changed"
305         rm $TMP/test14.junk $DIR1/d14/multiop || error "removing multiop"
306 }
307 run_test 14c "open(O_TRUNC) of executing file return -ETXTBSY =="
308
309 test_14d() { # bug 10921
310         mkdir -p $DIR1/d14
311         cp -p `which multiop` $DIR1/d14/multiop || error "cp failed"
312         $DIR1/d14/multiop $TMP/test14.junk O_c &
313         MULTIPID=$!
314         sleep 1
315         log chmod
316         chmod 600 $DIR1/d14/multiop || error "chmod failed"
317         kill -USR1 $MULTIPID || return 2
318         wait $MULTIPID || return 3
319         cmp `which multiop` $DIR1/d14/multiop || error "binary changed"
320         rm $TMP/test14.junk $DIR1/d14/multiop || error "removing multiop"
321 }
322 run_test 14d "chmod of executing file is still possible ========"
323
324 test_15() {     # bug 974 - ENOSPC
325         echo "PATH=$PATH"
326         sh oos2.sh $MOUNT1 $MOUNT2
327         grant_error=`dmesg | grep "> available"`
328         [ -z "$grant_error" ] || error "$grant_error"
329 }
330 run_test 15 "test out-of-space with multiple writers ==========="
331
332 test_16() {
333         rm -f $MOUNT1/fsxfile
334         lfs setstripe $MOUNT1/fsxfile -c -1 # b=10919
335         fsx -c 50 -p 100 -N 2500 -l $((SIZE * 256)) -S 0 $MOUNT1/fsxfile $MOUNT2/fsxfile
336 }
337 run_test 16 "2500 iterations of dual-mount fsx ================="
338
339 test_17() { # bug 3513, 3667
340         [ ! -d /proc/fs/lustre/ost ] && skip "remote OST, skipping OST-only test" && return
341
342         cp /etc/termcap $DIR1/f17
343         cancel_lru_locks osc > /dev/null
344         #define OBD_FAIL_ONCE|OBD_FAIL_LDLM_CREATE_RESOURCE    0x30a
345         sysctl -w lustre.fail_loc=0x8000030a
346         ls -ls $DIR1/f17 | awk '{ print $1,$6 }' > $DIR1/f17-1 & \
347         ls -ls $DIR2/f17 | awk '{ print $1,$6 }' > $DIR2/f17-2
348         wait
349         diff -u $DIR1/f17-1 $DIR2/f17-2 || error "files are different"
350 }
351 run_test 17 "resource creation/LVB creation race ==============="
352
353 test_18() {
354         ./mmap_sanity -d $MOUNT1 -m $MOUNT2
355         sync; sleep 1; sync
356 }
357 run_test 18 "mmap sanity check ================================="
358
359 test_19() { # bug3811
360         [ -d /proc/fs/lustre/obdfilter ] || return 0
361
362         MAX=`cat /proc/fs/lustre/obdfilter/*/readcache_max_filesize | head -n 1`
363         for O in /proc/fs/lustre/obdfilter/*OST*; do
364                 echo 4096 > $O/readcache_max_filesize
365         done
366         dd if=/dev/urandom of=$TMP/f19b bs=512k count=32
367         SUM=`cksum $TMP/f19b | cut -d" " -f 1,2`
368         cp $TMP/f19b $DIR1/f19b
369         for i in `seq 1 20`; do
370                 [ $((i % 5)) -eq 0 ] && log "test_18 loop $i"
371                 cancel_lru_locks osc > /dev/null
372                 cksum $DIR1/f19b | cut -d" " -f 1,2 > $TMP/sum1 & \
373                 cksum $DIR2/f19b | cut -d" " -f 1,2 > $TMP/sum2
374                 wait
375                 [ "`cat $TMP/sum1`" = "$SUM" ] || \
376                         error "$DIR1/f19b `cat $TMP/sum1` != $SUM"
377                 [ "`cat $TMP/sum2`" = "$SUM" ] || \
378                         error "$DIR2/f19b `cat $TMP/sum2` != $SUM"
379         done
380         for O in /proc/fs/lustre/obdfilter/*OST*; do
381                 echo $MAX > $O/readcache_max_filesize
382         done
383         rm $DIR1/f19b
384 }
385 #run_test 19 "test concurrent uncached read races ==============="
386
387 test_20() {
388         mkdir $DIR1/d20
389         cancel_lru_locks osc
390         CNT=$((`cat /proc/fs/lustre/llite/*/dump_page_cache | wc -l`))
391         multiop $DIR1/f20 Ow8190c
392         multiop $DIR2/f20 Oz8194w8190c
393         multiop $DIR1/f20 Oz0r8190c
394         cancel_lru_locks osc
395         CNTD=$((`cat /proc/fs/lustre/llite/*/dump_page_cache | wc -l` - $CNT))
396         [ $CNTD -gt 0 ] && \
397             error $CNTD" page left in cache after lock cancel" || true
398 }
399 run_test 20 "test extra readahead page left in cache ===="
400
401 cleanup_21() {
402         trap 0
403         umount $DIR1/d21
404 }
405
406 test_21() { # Bug 5907
407         mkdir $DIR1/d21
408         mount /etc $DIR1/d21 --bind || error "mount failed" # Poor man's mount.
409         trap cleanup_21 EXIT
410         rmdir -v $DIR1/d21 && error "Removed mounted directory"
411         rmdir -v $DIR2/d21 && echo "Removed mounted directory from another mountpoint, needs to be fixed"
412         test -d $DIR1/d21 || error "Mounted directory disappeared"
413         cleanup_21
414         test -d $DIR2/d21 || test -d $DIR1/d21 && error "Removed dir still visible after umount"
415         true
416 }
417 run_test 21 " Try to remove mountpoint on another dir ===="
418
419 JOIN=${JOIN:-"lfs join"}
420
421 test_22() { # Bug 9926
422         mkdir $DIR1/d21
423         dd if=/dev/urandom of=$DIR1/d21/128k bs=1024 count=128
424         cp -p $DIR1/d21/128k $DIR1/d21/f_head
425         for ((i=0;i<10;i++)); do
426                 cp -p $DIR1/d21/128k $DIR1/d21/f_tail
427                 $JOIN $DIR1/d21/f_head $DIR1/d21/f_tail || error "join error"
428                 $CHECKSTAT -a $DIR1/d21/f_tail || error "tail file exist after join"
429         done
430         echo aaaaaaaaaaa >> $DIR1/d21/no_joined
431
432         mv $DIR2/d21/f_head $DIR2/
433         munlink $DIR2/f_head || error "unlink joined file error"
434         cat $DIR2/d21/no_joined || error "cat error"
435         rm -rf $DIR2/d21/no_joined || error "unlink normal file error"
436 }
437 run_test 22 " After joining in one dir,  open/close unlink file in anther dir" 
438
439 test_23() { # Bug 5972
440         echo "others should see updated atime while another read" > $DIR1/f23
441         
442         # clear the lock(mode: LCK_PW) gotten from creating operation
443         cancel_lru_locks osc
444         
445         time1=`date +%s`        
446         sleep 2
447         
448         multiop $DIR1/f23 or20_c &
449         MULTIPID=$!
450
451         sleep 2
452         time2=`stat -c "%X" $DIR2/f23`
453
454         if (( $time2 <= $time1 )); then
455                 kill -USR1 $MULTIPID
456                 error "atime doesn't update among nodes"
457         fi
458
459         kill -USR1 $MULTIPID || return 1
460         rm -f $DIR1/f23 || error "rm -f $DIR1/f23 failed"
461         true
462 }
463 run_test 23 " others should see updated atime while another read===="
464
465 test_24() {
466         touch $DIR1/$tfile
467         lfs df || error "lfs df failed"
468         lfs df -ih || error "lfs df -ih failed"
469         lfs df -h $DIR1 || error "lfs df -h $DIR1 failed"
470         lfs df -i $DIR2 || error "lfs df -i $DIR2 failed"
471         lfs df $DIR1/$tfile || error "lfs df $DIR1/$tfile failed"
472         lfs df -ih $DIR2/$tfile || error "lfs df -ih $DIR2/$tfile failed"
473         
474         OSC=`lctl dl | awk '/-osc-|OSC.*MNT/ {print $4}' | head -n 1`
475 #       OSC=`lctl dl | awk '/-osc-/ {print $4}' | head -n 1`
476         lctl --device %$OSC deactivate
477         lfs df -i || error "lfs df -i with deactivated OSC failed"
478         lctl --device %$OSC recover
479         lfs df || error "lfs df with reactivated OSC failed"
480 }
481 run_test 24 "lfs df [-ih] [path] test ========================="
482
483 test_25() {
484         [ `lctl get_param -n mdc.*-mdc-*.connect_flags | grep -c acl` -lt 2 ] && \
485             skip "must have acl, skipping" && return
486
487         touch $DIR1/$tdir/f1 || error "touch $DIR1/$tdir/f1"
488         chmod 0755 $DIR1/$tdir/f1 || error "chmod 0755 $DIR1/$tdir/f1"
489
490         $RUNAS $CHECKSTAT $DIR2/$tdir/f1 || error "checkstat $DIR2/$tdir/f1 #1"
491         setfacl -m u:$RUNAS_ID:--- $DIR1/$tdir || error "setfacl $DIR2/$tdir #1"
492         $RUNAS $CHECKSTAT $DIR2/$tdir/f1 && error "checkstat $DIR2/$tdir/f1 #2"
493         setfacl -m u:$RUNAS_ID:r-x $DIR1/$tdir || error "setfacl $DIR2/$tdir #2"
494         $RUNAS $CHECKSTAT $DIR2/$tdir/f1 || error "checkstat $DIR2/$tdir/f1 #3"
495         setfacl -m u:$RUNAS_ID:--- $DIR1/$tdir || error "setfacl $DIR2/$tdir #3"
496         $RUNAS $CHECKSTAT $DIR2/$tdir/f1 && error "checkstat $DIR2/$tdir/f1 #4"
497         setfacl -x u:$RUNAS_ID: $DIR1/$tdir || error "setfacl $DIR2/$tdir #4"
498         $RUNAS $CHECKSTAT $DIR2/$tdir/f1 || error "checkstat $DIR2/$tdir/f1 #5"
499
500         rm -rf $DIR1/$tdir
501 }
502 run_test 25 "change ACL on one mountpoint be seen on another ==="
503
504 test_26a() {
505         utime $DIR1/f26a -s $DIR2/f26a || error
506 }
507 run_test 26a "allow mtime to get older"
508
509 test_26b() {
510         touch $DIR1/$tfile
511         sleep 1
512         echo "aaa" >> $DIR1/$tfile
513         sleep 1
514         chmod a+x $DIR2/$tfile
515         mt1=`stat -c %Y $DIR1/$tfile`
516         mt2=`stat -c %Y $DIR2/$tfile`
517         
518         if [ x"$mt1" != x"$mt2" ]; then 
519                 error "not equal mtime, client1: "$mt1", client2: "$mt2"."
520         fi
521 }
522 run_test 26b "sync mtime between ost and mds"
523
524 test_27() {
525         cancel_lru_locks osc
526         lctl clear
527         dd if=/dev/zero of=$DIR2/$tfile bs=$((4096+4))k conv=notrunc count=4 seek=3 &
528         DD2_PID=$!
529         usleep 50
530         log "dd 1 started"
531         
532         dd if=/dev/zero of=$DIR1/$tfile bs=$((16384-1024))k conv=notrunc count=1 seek=4 &
533         DD1_PID=$!
534         log "dd 2 started"
535         
536         sleep 1
537         dd if=/dev/zero of=$DIR1/$tfile bs=8k conv=notrunc count=1 seek=0
538         log "dd 3 finished"
539         lctl set_param -n ldlm.dump_namespaces ""
540         wait $DD1_PID $DD2_PID
541         [ $? -ne 0 ] && lctl dk $TMP/debug || true
542 }
543 run_test 27 "align non-overlapping extent locks from request ==="
544
545 test_28() { # bug 9977
546         ECHO_UUID="ECHO_osc1_UUID"
547         tOST=`$LCTL dl | | awk '/-osc-|OSC.*MNT/ { print $4 }' | head -1`
548
549         lfs setstripe $DIR1/$tfile -s 1048576 -i 0 -c 2
550         tOBJID=`lfs getstripe $DIR1/$tfile |grep "^[[:space:]]\+1" |awk '{print $2}'`
551         dd if=/dev/zero of=$DIR1/$tfile bs=1024k count=2
552
553         $LCTL <<-EOF
554                 newdev
555                 attach echo_client ECHO_osc1 $ECHO_UUID
556                 setup $tOST
557         EOF
558
559         tECHOID=`$LCTL dl | grep $ECHO_UUID | awk '{print $1}'`
560         $LCTL --device $tECHOID destroy "${tOBJID}:0"
561     
562         $LCTL <<-EOF
563                 cfg_device ECHO_osc1
564                 cleanup
565                 detach
566         EOF
567
568         # reading of 1st stripe should pass
569         dd if=$DIR2/$tfile of=/dev/null bs=1024k count=1 || error
570         # reading of 2nd stripe should fail (this stripe was destroyed)
571         dd if=$DIR2/$tfile of=/dev/null bs=1024k count=1 skip=1 && error
572
573         # now, recreating test file
574         dd if=/dev/zero of=$DIR1/$tfile bs=1024k count=2 || error
575         # reading of 1st stripe should pass
576         dd if=$DIR2/$tfile of=/dev/null bs=1024k count=1 || error
577         # reading of 2nd stripe should pass
578         dd if=$DIR2/$tfile of=/dev/null bs=1024k count=1 skip=1 || error
579 }
580 run_test 28 "read/write/truncate file with lost stripes"
581
582 test_29() { # bug 10999
583         touch $DIR1/$tfile
584         #define OBD_FAIL_LDLM_GLIMPSE  0x30f
585         sysctl -w lustre.fail_loc=0x8000030f
586         ls -l $DIR2/$tfile &
587         usleep 500
588         dd if=/dev/zero of=$DIR1/$tfile bs=4k count=1
589         wait
590 }
591 #bug 11549 - permanently turn test off in b1_5
592 #run_test 29 "lock put race between glimpse and enqueue ========="
593
594 test_30() { #bug #11110
595     cp -f /bin/bash $DIR1/$tdir/bash
596     /bin/sh -c 'sleep 1; rm -f $DIR2/$tdir/bash; cp /bin/bash $DIR2/$tdir' &
597     err=$($DIR1/$tdir/bash -c 'sleep 2; openfile -f O_RDONLY /proc/$$/exe >& /dev/null; echo $?')
598     wait
599     [ $err -ne 116 ] && error_ignore 12900 "return code ($err) != -ESTALE" && return
600     true
601 }
602
603 run_test 30 "recreate file race ========="
604
605 test_31() {
606         mkdir -p $DIR1/$tdir || error "Creating dir $DIR1/$tdir"
607         writes=`LANG=C dd if=/dev/zero of=$DIR/$tdir/$tfile count=1 2>&1 |
608                 awk 'BEGIN { FS="+" } /out/ {print $1}'`
609         #define OBD_FAIL_LDLM_CANCEL_BL_CB_RACE   0x314
610         sysctl -w lustre.fail_loc=0x314
611         reads=`LANG=C dd if=$DIR2/$tdir/$tfile of=/dev/null 2>&1 |
612                awk 'BEGIN { FS="+" } /in/ {print $1}'`
613         [ $reads -eq $writes ] || error "read" $reads "blocks, must be" $writes
614 }
615 run_test 31 "voluntary cancel / blocking ast race=============="
616
617 log "cleanup: ======================================================"
618
619 check_and_cleanup_lustre
620
621 echo '=========================== finished ==============================='
622 [ -f "$SANITYLOG" ] && cat $SANITYLOG && grep -q FAIL $SANITYLOG && exit 1 || true
623 echo "$0: completed"